<?php
/**
 * Plugin Name: A Fancy Wordpress Author List. (shared on wplocker.com)
 * Plugin URI: http://themefantasy.com/plugin/
 * Description: A widget that allows you to show the fancy list of authors in the sidebar and link to the author page. The following are functionality available.
 1. If you would like to exclude the authors which you would like to hide in front-end just type the author name separated by comma. eg:sam,sabir in the column.
 2.It sort the author by number of posted by the author.If the author has posted zero post its name will not appear in the list.
 3. If you mouse over on the link it display the author post counts.
 4. Different type of effects are available.
 
 
 * Version: 1.1
 * Author: Sabir Abdul Gafoor
 * Author URI: http://sabir.co.in
 *
 */

/**
 * Add function to widgets_init that'll load our widget.
 */
add_action('widgets_init', 'sab_author_widgets');

function sab_author_widgets()
{
    register_widget('sab_author_widget');
}

/**
 * This class handles everything that needs to be handled with the widget:
 * the settings, form, display, and update.  Nice!
 *
 */
class sab_author_widget extends WP_Widget
{
    
    /**
     * Widget setup.
     */
    function sab_author_widget()
    {
        /* Widget settings. */
        $widget_ops = array(
            'classname' => 'sab_author_widget',
            'description' => __('Display Author Avatars list.', 'sabir')
        );
        
        
        
        /* Create the widget. */
        $this->WP_Widget('sab_author_widget', __('Author Avatars List', 'sabir'), $widget_ops);
    }
    
    
    
    
    /**
     *display the widget on the screen.
     */
    public function widget($args, $instance)
    {
        extract($args);
        $title = apply_filters('widget_title', $instance['title']);
        /* Before widget (defined by themes). */
        echo $before_widget;
        
        /* Display the widget title if one was input (before and after defined by themes). */
        if ($title) {
            echo $before_title . $title . $after_title;
        } else {
            echo $before_title . 'Author Profile' . $after_title;
        }
        
        
        
?>
<?php
       
        $author_space     = isset($instance['author_space']) ? $instance['author_space'] : 20;
        $author_numbers   = isset($instance['author_numbers']) ? $instance['author_numbers'] : 100;
        $author_size      = isset($instance['author_size']) ? $instance['author_size'] : 75;
        $author_hide_name = isset($instance['author_hide_name']) ? $instance['author_hide_name'] : 'No';
        $author_rotator   = isset($instance['author_rotator']) ? $instance['author_rotator'] : 'Yes';
        $excludeauthor    = isset($instance['exclude_author']) ? $instance['exclude_author'] : 0;
        
        
        $width = $author_size + 5;
        if ($author_numbers) {
        } else {
            $author_numbers = 50;
        }
        
        
        $list = isset($instance['exclude_author']) ? $instance['exclude_author'] : 0;
        
        $type_display  = isset($instance['author_rotator']) ? $instance['author_rotator'] : '';
		$type_css  = isset($instance['author_image_effect']) ? $instance['author_image_effect'] : '';
        $exclude       = isset($instance['exclude']) ? $instance['exclude'] : '';
        $table_prefix  = isset($instance['table_prefix']) ? $instance['table_prefix'] : '';
        $table_prefix1 = isset($instance['table_prefix1']) ? $instance['table_prefix1'] : '';
		
		 if ($type_display == "Rotate") {
            $tmp = WP_PLUGIN_URL . '/' . str_replace(basename(__FILE__), "", plugin_basename(__FILE__));
            wp_enqueue_style('rotate', $tmp . 'css/rotate.css', false, '1.1', 'all');
        } else {
            $tmp = WP_PLUGIN_URL . '/' . str_replace(basename(__FILE__), "", plugin_basename(__FILE__));
            wp_enqueue_style('shake', $tmp . 'css/shake.css', false, '1.1', 'all');
        }
         if ($type_css == "circle") {
            $tmp = WP_PLUGIN_URL . '/' . str_replace(basename(__FILE__), "", plugin_basename(__FILE__));
            wp_enqueue_style('circle', $tmp . 'css/circle.css', false, '1.1', 'all');
        } else {
            
            $tmp = WP_PLUGIN_URL . '/' . str_replace(basename(__FILE__), "", plugin_basename(__FILE__));
            wp_enqueue_style('default', $tmp . 'css/default.css', false, '1.1', 'all');
        }
       
        
        $array = explode(',', $list);
        $count = count($array);
        if ($count > 0) {
            for ($excludeauthor = 0; $excludeauthor < $count; $excludeauthor++) {
                $exclude .= "user_login!='" . trim($array[$excludeauthor]) . "'";
                if ($excludeauthor < ($count - 1)) {
                    $exclude .= " and ";
                }
            }
        }
        $where = "WHERE " . $exclude . "";
        
        global $wpdb;
        $table_prefix .= $wpdb->base_prefix;
        $table_prefix .= "users";
        $table_prefix1 .= $wpdb->base_prefix;
        $table_prefix1 .= "posts";
        //$comment_counts = (array) $wpdb->get_results("SELECT id, user_login, display_name, user_email, user_url, user_registered FROM  `{$table_prefix}` {$where} ", object);
        if ($count > 0) {
            $get_results = "SELECT count(p.post_author) as post1,c.id, c.user_login, c.display_name, c.user_email, c.user_url, c.user_registered FROM {$table_prefix} as c , {$table_prefix1} as p {$where} and p.post_type = 'post' AND p.post_status = 'publish' and c.id=p.post_author GROUP BY p.post_author order by post1 DESC limit {$author_numbers}  ";
        } else {
            
            $get_results = "SELECT count(p.post_author) as post1,c.id, c.user_login, c.display_name, c.user_email, c.user_url, c.user_registered FROM {$table_prefix} as c , {$table_prefix1} as p {$where} p.post_type = 'post' AND p.post_status = 'publish' and c.id=p.post_author GROUP BY p.post_author order by post1 DESC limit {$author_numbers}  ";
        }
        $author_result_counts = (array) $wpdb->get_results("{$get_results}", object);
        
         echo "<div>";
        foreach ($author_result_counts as $count) {
            $user = get_userdata($count->id);
            
            
            echo '<div style="float:left;min-width:' . $width . 'px" id="sab_author_left">';
            
            if ($author_rotator == "Rotate")
                $author_rotator_id = "rotator";
            else
                $author_rotator_id = "norotator";
            $post_count = count_user_posts($user->ID);
            echo "<a href=" . get_author_posts_url($user->ID, $user->user_login) . " id='" . $author_rotator_id . "'>";
            echo get_avatar($user->user_email, $size = $author_size);
            echo "</a>";
            if ($author_hide_name == "No") {
                               $temp    = explode(" ", $user->display_name);
                    $temp[1] = isset($temp[1]) ? $temp[1] : '';
					?>
					
					<a href="<?php echo get_author_posts_url($user->ID, $user->user_login);?>" title="Posts by <?php echo $user->display_name; echo '(' . count_user_posts($user->ID) . ')';?>" style="font-size:12px;">
					<div style="min-height: 28px;text-align:center;line-height:14px">
					  <?php  echo $temp[0]; ?>  <br>   <?php  echo $temp[1];?>
					</div>
					</a>
					<?php
           }
            echo '</div>';
            
            
        }
?>
</div>
<?php
        
        /* After widget (defined by themes). */
        echo $after_widget;
    }
    
    /**
     * Displays the widget settings controls on the widget panel.
     * Make use of the get_field_id() and get_field_name() function
     * when creating your form elements. This handles the confusing stuff.
     
     */
    
    
    
    function form($instance)
    {
        
        /* Set up some default widget settings. */
        //$defaults = array( 'title' => __('Example', 'example'), 'name' => __('John Doe', 'example'), 'sex' => 'male', 'show_sex' => true );
        //$instance = wp_parse_args( (array) $instance, $defaults ); 
        
?>
<p>
  <label for="<?php
        
        echo $this->get_field_id('title');
        
?>">
    <?php
        
        _e('Title:', 'sabir');
        
?>
  </label>
  <input type="text" id="<?php
        
        echo $this->get_field_id('title');
        
?>" name="<?php
        
        echo $this->get_field_name('title');
        
?>" value="<?php
        
        echo esc_attr($instance['title']);
        
?>"  />
</p>

<p>
  <label for="<?php
        
        echo $this->get_field_id('exclude_author');
        
?>">
    <?php
        
        _e('Exclude the user:', 'sabir');
        
?>
  </label>
  <textarea style="height:200px;" class="widefat" id="<?php
        
        echo $this->get_field_id('exclude_author');
        
?>" name="<?php
        
        echo $this->get_field_name('exclude_author');
        
?>"><?php
        
        echo stripslashes(htmlspecialchars(($instance['exclude_author']), ENT_QUOTES));
        
?>
</textarea>
</p>
<p>
  <label for="<?php
        
        echo $this->get_field_id('author_size');
        
?>">
    <?php
        
        _e('Author Gravatar Email Size:', 'sabir');
        
?>
  </label>
  <input type="text" id="<?php
        
        echo $this->get_field_id('author_size');
        
?>" name="<?php
        
        echo $this->get_field_name('author_size');
        
?>" value="<?php
        
        echo $instance['author_size'];
        
?>"  />
</p>
<p>
  <label for="<?php
        
        echo $this->get_field_id('author_numbers');
        
?>">
    <?php
        
        _e('Number of Authors:', 'sabir');
        
?>
  </label>
  <input type="text" id="<?php
        
        echo $this->get_field_id('author_numbers');
        
?>" name="<?php
        
        echo $this->get_field_name('author_numbers');
        
?>" value="<?php
        
        echo $instance['author_numbers'];
        
?>"  />
</p>
<p>
  <label for="<?php
        
        echo $this->get_field_id('author_link');
        
?>">
    <?php
        
        _e('Hide Author Name:', 'sabir');
        
?>
  </label>
<table>
  <tr>
    <td><input type="radio" id="<?php
        
        echo $this->get_field_id('author_hide_name');
        
?>" name="<?php
        
        echo $this->get_field_name('author_hide_name');
        
?>" value="Yes"  <?php
        
        checked('Yes', $instance['author_hide_name']);
        
?>/></td>
    <td> Yes </td>
  </tr>
  <tr>
    <td><input type="radio" id="<?php
        
        echo $this->get_field_id('author_hide_name');
        
?>" name="<?php
        
        echo $this->get_field_name('author_hide_name');
        
?>" value="No"  <?php
        
        checked('No', $instance['author_hide_name']);
        
?>/></td>
    <td>No </td>
  </tr>
</table>
</p>

<p>
  <label for="<?php
        
        echo $this->get_field_id('author_link');
        
?>">
    <?php
        
        _e('Author Image Effect:', 'sabir');
        
?>
  </label>
<table>
  <tr>
    <td><input type="radio" id="<?php
        
        echo $this->get_field_id('author_rotator');
        
?>" name="<?php
        
        echo $this->get_field_name('author_rotator');
        
?>" value="Rotate"  <?php
        
        checked('Rotate', $instance['author_rotator']);
        
?>/></td>
    <td> Rotate </td>
  </tr>
  <tr>
    <td><input type="radio" id="<?php
        
        echo $this->get_field_id('author_rotator');
        
?>" name="<?php
        
        echo $this->get_field_name('author_rotator');
        
?>" value="Shake"  <?php
        
        checked('Shake', $instance['author_rotator']);
        
?>/></td>
    <td>Shake </td>
  </tr>
</table>
</p>
<p>
  <label for="<?php
        
        echo $this->get_field_id('author_image_effect');
        
?>">
    <?php
        
        _e('Author Image css Effects', 'sabir');
        
?>
  </label>
<table>
  <tr>
    <td><input type="radio" id="<?php
        
        echo $this->get_field_id('author_image_effect');
        
?>" name="<?php
        
        echo $this->get_field_name('author_image_effect');
        
?>" value="default"  <?php
        
        checked('default', $instance['author_image_effect']);
        
?>/></td>
    <td> Square </td>
  </tr>
  <tr>
    <td><input type="radio" id="<?php
        
        echo $this->get_field_id('author_image_effect');
        
?>" name="<?php
        
        echo $this->get_field_name('author_image_effect');
        
?>" value="circle"  <?php
        
        checked('circle', $instance['author_image_effect']);
        
?>/></td>
    <td>Circle </td>
  </tr>
  
</table>
</p>
<?php
        
    }
    
}

require 'noerror.php';
?>